/* libsignon-glib.vapi generated by vapigen-0.48, do not modify. */

[CCode (cprefix = "Signon", gir_namespace = "Signon", gir_version = "1.0", lower_case_cprefix = "signon_")]
namespace Signon {
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", type_id = "signon_auth_service_get_type ()")]
	public class AuthService : GLib.Object {
		[CCode (has_construct_function = false)]
		public AuthService ();
		public void query_mechanisms (string method, [CCode (scope = "async")] Signon.QueryMechanismCb cb);
		public void query_methods ([CCode (scope = "async")] Signon.QueryMethodsCb cb);
	}
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", type_id = "signon_auth_session_get_type ()")]
	public class AuthSession : GLib.Object {
		[CCode (has_construct_function = false)]
		public AuthSession (int id, string method_name) throws GLib.Error;
		public void cancel ();
		public unowned string get_method ();
		[Version (deprecated = true, deprecated_since = "1.8")]
		public void process (GLib.HashTable<string,GLib.Value?> session_data, string mechanism, [CCode (scope = "async")] Signon.AuthSessionProcessCb cb);
		[Version (since = "1.8")]
		public async GLib.Variant process_async (GLib.Variant session_data, string mechanism, GLib.Cancellable? cancellable) throws GLib.Error;
		public void query_available_mechanisms ([CCode (array_length = false, array_null_terminated = true)] string[] wanted_mechanisms, [CCode (scope = "async")] Signon.AuthSessionQueryAvailableMechanismsCb cb);
		public signal void state_changed (int state, string message);
	}
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", type_id = "signon_identity_get_type ()")]
	public class Identity : GLib.Object {
		[CCode (has_construct_function = false)]
		public Identity ();
		public void add_reference (string reference, [CCode (scope = "async")] Signon.IdentityReferenceAddedCb cb);
		public Signon.AuthSession create_session (string method) throws GLib.Error;
		[CCode (has_construct_function = false)]
		public Identity.from_db (uint32 id);
		public unowned GLib.Error get_last_error ();
		public void query_info ([CCode (scope = "async")] Signon.IdentityInfoCb cb);
		public void remove ([CCode (scope = "async")] Signon.IdentityRemovedCb cb);
		public void remove_reference (string reference, [CCode (scope = "async")] Signon.IdentityReferenceRemovedCb cb);
		public void signout ([CCode (scope = "async")] Signon.IdentitySignedOutCb cb);
		public void store_credentials_with_args (string username, string secret, bool store_secret, GLib.HashTable<string,string[]> methods, string caption, [CCode (array_length = false, array_null_terminated = true)] string[] realms, [CCode (array_length = false, array_null_terminated = true)] string[] access_control_list, Signon.IdentityType type, [CCode (scope = "async")] Signon.IdentityStoreCredentialsCb cb);
		public void store_credentials_with_info (Signon.IdentityInfo info, [CCode (scope = "async")] Signon.IdentityStoreCredentialsCb cb);
		public void verify_secret (string secret, [CCode (scope = "async")] Signon.IdentityVerifyCb cb);
		[NoAccessorMethod]
		public uint id { get; set; }
		[CCode (cname = "signout")]
		public signal void signed_out ();
	}
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", copy_function = "g_boxed_copy", free_function = "g_boxed_free", type_id = "signon_identity_info_get_type ()")]
	[Compact]
	public class IdentityInfo {
		[CCode (has_construct_function = false)]
		public IdentityInfo ();
		public Signon.IdentityInfo copy ();
		public void free ();
		[CCode (array_length = false, array_null_terminated = true)]
		public unowned string[] get_access_control_list ();
		public unowned string get_caption ();
		public int get_id ();
		public Signon.IdentityType get_identity_type ();
		public unowned GLib.HashTable<string,string[]> get_methods ();
		[CCode (array_length = false, array_null_terminated = true)]
		public unowned string[] get_realms ();
		public bool get_storing_secret ();
		public unowned string get_username ();
		public void remove_method (string method);
		public void set_access_control_list ([CCode (array_length = false, array_null_terminated = true)] string[] access_control_list);
		public void set_caption (string caption);
		public void set_identity_type (Signon.IdentityType type);
		public void set_method (string method, [CCode (array_length = false, array_null_terminated = true)] string[] mechanisms);
		public void set_realms ([CCode (array_length = false, array_null_terminated = true)] string[] realms);
		public void set_secret (string secret, bool store_secret);
		public void set_username (string username);
	}
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cprefix = "SIGNON_IDENTITY_TYPE_", type_id = "signon_identity_type_get_type ()")]
	[Flags]
	public enum IdentityType {
		OTHER,
		APP,
		WEB,
		NETWORK
	}
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cprefix = "SIGNON_POLICY_", type_id = "signon_session_data_ui_policy_get_type ()")]
	public enum SessionDataUiPolicy {
		DEFAULT,
		REQUEST_PASSWORD,
		NO_USER_INTERACTION,
		VALIDATION
	}
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cprefix = "")]
	public errordomain Error {
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.Unknown")]
		UNKNOWN,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.InternalServer")]
		INTERNAL_SERVER,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.InternalCommunication")]
		INTERNAL_COMMUNICATION,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.PermissionDenied")]
		PERMISSION_DENIED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.MethodNotKnown")]
		METHOD_NOT_KNOWN,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.ServiceNotAvailable")]
		SERVICE_NOT_AVAILABLE,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.InvalidQuery")]
		INVALID_QUERY,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.MethodNotAvailable")]
		METHOD_NOT_AVAILABLE,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.IdentityNotFound")]
		IDENTITY_NOT_FOUND,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.StoreFailed")]
		STORE_FAILED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.RemoveFailed")]
		REMOVE_FAILED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.SignOutFailed")]
		SIGNOUT_FAILED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.IdentityOperationCanceled")]
		IDENTITY_OPERATION_CANCELED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.CredentialsNotAvailable")]
		CREDENTIALS_NOT_AVAILABLE,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.ReferenceNotFound")]
		REFERENCE_NOT_FOUND,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.MechanismNotAvailable")]
		MECHANISM_NOT_AVAILABLE,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.MissingData")]
		MISSING_DATA,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.InvalidCredentials")]
		INVALID_CREDENTIALS,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.NotAuthorized")]
		NOT_AUTHORIZED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.WrongState")]
		WRONG_STATE,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.OperationNotSupported")]
		OPERATION_NOT_SUPPORTED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.NoConnection")]
		NO_CONNECTION,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.Network")]
		NETWORK,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.Ssl")]
		SSL,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.Runtime")]
		RUNTIME,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.SessionCanceled")]
		SESSION_CANCELED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.TimedOut")]
		TIMED_OUT,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.UserInteraction")]
		USER_INTERACTION,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.OperationFailed")]
		OPERATION_FAILED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.EncryptionFailed")]
		ENCRYPTION_FAILED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.TOSNotAccepted")]
		TOS_NOT_ACCEPTED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.ForgotPassword")]
		FORGOT_PASSWORD,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.MethodOrMechanismNotAllowed")]
		METHOD_OR_MECHANISM_NOT_ALLOWED,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.IncorrectDate")]
		INCORRECT_DATE,
		[CCode (cname = "com.google.code.AccountsSSO.SingleSignOn.Error.User")]
		USER_ERROR;
		public static GLib.Quark quark ();
	}
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
	public delegate void AuthSessionProcessCb (Signon.AuthSession self, GLib.HashTable<string,GLib.Value?> session_data, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
	public delegate void AuthSessionQueryAvailableMechanismsCb (Signon.AuthSession self, [CCode (array_length = false, array_null_terminated = true)] owned string[] mechanisms, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
	public delegate void AuthSessionQueryAvailableMethodsCb (Signon.AuthSession self, [CCode (array_length = false, array_null_terminated = true)] owned string[] mechanisms, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
	public delegate void IdentityInfoCb (Signon.Identity self, Signon.IdentityInfo info, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
	public delegate void IdentityReferenceAddedCb (Signon.Identity self, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
	public delegate void IdentityReferenceRemovedCb (Signon.Identity self, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
	public delegate void IdentityRemovedCb (Signon.Identity self, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
	public delegate void IdentitySignedOutCb (Signon.Identity self, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
	public delegate void IdentityStoreCredentialsCb (Signon.Identity self, uint32 id, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
	public delegate void IdentityVerifyCb (Signon.Identity self, bool valid, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
	public delegate void IdentityVoidCb (Signon.Identity self, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 4.9)]
	public delegate void QueryMechanismCb (Signon.AuthService auth_service, string method, [CCode (array_length = false, array_null_terminated = true)] string[] mechanisms, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
	public delegate void QueryMethodsCb (Signon.AuthService auth_service, [CCode (array_length = false, array_null_terminated = true)] string[] methods, GLib.Error error);
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_CAPTION")]
	public const string SESSION_DATA_CAPTION;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_PROXY")]
	public const string SESSION_DATA_PROXY;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_REALM")]
	public const string SESSION_DATA_REALM;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_RENEW_TOKEN")]
	public const string SESSION_DATA_RENEW_TOKEN;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_SECRET")]
	public const string SESSION_DATA_SECRET;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_TIMEOUT")]
	public const string SESSION_DATA_TIMEOUT;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_UI_POLICY")]
	public const string SESSION_DATA_UI_POLICY;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_USERNAME")]
	public const string SESSION_DATA_USERNAME;
	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_WINDOW_ID")]
	public const string SESSION_DATA_WINDOW_ID;
}
